/*                      LEKCJA08.C
//---------------------------------------------------------------------------
Temat:
        Definiowanie elementu WYMIAROWANIE
//---------------------------------------------------------------------------
Funkcje:
        EXT(217) void GetDimVal(       
        EXT(218) void PrintDimVal(     
//---------------------------------------------------------------------------

   Wymiarowanie wydaje si na pocztku trudnym przedsiwziciem, jednake po 
   zrozumieniu moliwoci jakie daj funkcje pomocnicze 'GetDimVal' i
   'PrintDimVal' otwiera si caa paleta zastosowa.

typedef struct _dimension
{
    t_txtval val;        // atrybuty tekstu (opisane wczeniej)
    double   tx;         // wsprzdna pocztku warto X
    double   ty;         // wsprzdna pocztku warto Y   
    double   dx1;        // wektor linii podstawowej warto X
    double   dy1;        // wektor linii podstawowej warto Y     
    double   dx2;        // wektor nachylenia warto X 
    double   dy2;        // wektor nachylenia warto Y 
    double   x1;         //
    double   y1;         // 1. punkt
    double   x2;         //
    double   y2;         // 2. punkt
    double   x3;         //
    double   y3;         // 3. punkt
    double   x4;         //
    double   y4;         // 4. punkt
    double   a_hig;      // wysoko strzaki wymiarowej
    double   a_wid;      // szeroko strzaki wymiarowej  
    double   a_len;      // dugo strzaki wymiarowej  
    double   value;      // zmierzona warto
    uchar    nins;       // czy bez linii przy wymiarze zewntrznym?
    uchar    plft;       // czy 1 strzaka jest kkiem ?
    uchar    prgt;       // czy 2 strzaka jest kkiem ?    
    uchar    tpen;       // numer pisaka plotera dla wymiarowania
    uchar    vpos;       // pozycja pionowa (lewa, prawa, rodek, dowolna)
    uchar    hpos;       // pozycja pozioma (lewa, prawa, rodek, dowolna)
    uchar    reli;       // ktre linie wymiarowe maj by przedstawione
    uchar    str2;       // obydwie wartoci tolerancji ?
    uchar    para;       // czy tekst ma by rwnolegy do linii wymiarowej
    uchar    edit;       // czy edytowano warto wymiaru ?
    uchar    xyon;       // typ wymiaru wsprzdnych (0-2)
    uchar    insd;       // wymiar wewntrzny ?
    uchar    mpfl;       // typ strzaki (1 - 7)
    uchar    mbox;       // E_T_DIM z prostoktem ?
    char     _far *str;  // tekst
} t_dimension;
//---------------------------------------------------------------------------

EXT(217) void GetDimVal(       // 
             ushort      type, // typ wymiarowania
             ushort      init, // inicjalizacja
             t_dimension *dim);// dane tekstu

Opis:
    Funkcja uatwiajca wczytanie ustawionych parametrw wymiarowania.
    Zmienna 'init' moe przyjmowa nastpujce wartoci:
    (init & 1) - wczatanie aktualnych wartoci wraz ze strzak wymiarow
    (init & 2) - ustawienie tekstu wymiarowego
    (init&4) - wczytanie tylko wartoci strzaki wymiarowej
    (init&0) - przeliczenie prostokta tekstu

Przykad wywoania:
    GetDimVal(E_H_DIM,7,&dim);
//---------------------------------------------------------------------------

  Funkcja uatwiajca wpisanie danych do wymiarowania - tworzenie tekstu
  wymiarowania.

EXT(218) void PrintDimVal(     // 
             double value,     // zmierzona warto wymiaru
             char   *str,      // bufor tekstowy
             char   *tol1,     // 1. tekst tolerancji (gra)
             char   *tol2);    // 2. tekst tolerancji (d)

Opis:
    Zmienna 'str' musi by wczeniej zdefiniowana.
    Zmienne 'tol1' i 'tol2' mog zawiera maksimum po 40 znakw.
    Zmienne 'tol1' i 'tol2' mog by puste: "" , ale nie NULL !

Przykad wywoania:
    PrintDimVal(dim.value,str,"","");

*/
//---------------------------------------------------------------------------
#include "std.h"
#include "megatyp.h"
#include "megacad.h"
//---------------------------------------------------------------------------
short main(char *filename, char *args )
{
   double      y;
   t_entity    ent;
   t_dimension dim;
   char        str[255];

   SetFuncText("Wymiar poziomy linii");
   MouseHelp("wska lini","powrt",HLP_INV(RED,WHITE,0));

                // wczytanie wartoci wskazanego elementu typu E_LINE
   while(ClickEntity((1<<E_LINE),&dim.x1,&ent,NULL,0))
   {
                // pocztek linii jest pocztkiem wymiaru
      dim.x1 = ent.data.lin.x1;

                // znalezienie wyszego koca linii
      y = ent.data.lin.y2;
      if(ent.data.lin.y1 > ent.data.lin.y2) y = ent.data.lin.y1;
      dim.y1 = y;

                // koniec linii jest kocem wymiaru
      dim.x2 = ent.data.lin.x2;
      dim.y2 = y;

                // podniesienie linii wymiarowej  o 5 jednostek do gry
      dim.x3 = dim.x1;
      dim.y3 = dim.y1 + 5;
      dim.x4 = dim.x2;
      dim.y4 = dim.y1 + 5;
                // warto wymiaru
      dim.value = fabs(dim.x2 - dim.x1);
                // przekazanie wartoci do bufora tekstu
      dim.str = str;
                // teksty tolerancji pozostaj niezdefiniowane - puste
      PrintDimVal(dim.value,str,"","");
                // wczytanie wartoci definiujcych wymiar poziomy
      GetDimVal(E_H_DIM,7,&dim);
      CreateEntity(E_H_DIM,NULL,&dim);
      savecount();
   }
}
//---------------------------------------------------------------------------
